Index: typo3/sysext/install/mod/class.tx_install.php
===================================================================
--- typo3/sysext/install/mod/class.tx_install.php	(revision 5575)
+++ typo3/sysext/install/mod/class.tx_install.php	(working copy)
@@ -3354,7 +3354,7 @@
 		$out='';
 		$out.='<tr>
 				<td nowrap="nowrap"><strong>'.$this->fw('Update required tables').'</strong></td>
-				<td'.($action_type=='cmpFile|CURRENT_TABLES'?' class="note"':'').'>'.$this->fw('<a href="'.htmlspecialchars($this->action.'&TYPO3_INSTALL[database_type]=cmpFile|CURRENT_TABLES#bottom').'"><strong>COMPARE</strong></a>').'</td>
+				<td' . ($action_type == 'cmpFile|CURRENT_TABLES' ? ' class="information"' : '') . '>' . $this->fw('<a href="' . htmlspecialchars($this->action . '&TYPO3_INSTALL[database_type]=cmpFile|CURRENT_TABLES#bottom') . '"><strong>COMPARE</strong></a>') . '</td>
 				<td>'.$this->fw('&nbsp;').'</td>
 				<td>'.$this->fw('&nbsp;').'</td>
 			</tr>';
@@ -3362,7 +3362,7 @@
 		$out.='<tr>
 				<td nowrap="nowrap"><strong>'.$this->fw('Dump static data').'</strong></td>
 				<td>'.$this->fw('&nbsp;').'</td>
-				<td nowrap="nowrap"'.($action_type=='import|CURRENT_STATIC'?' class="note"':'').'>'.$this->fw('<a href="'.htmlspecialchars($this->action.'&TYPO3_INSTALL[database_type]=import|CURRENT_STATIC#bottom').'"><strong>IMPORT</strong></a>').'</td>
+				<td nowrap="nowrap"' . ($action_type == 'import|CURRENT_STATIC' ? ' class="information"' : '') . '>' . $this->fw('<a href="' . htmlspecialchars($this->action . '&TYPO3_INSTALL[database_type]=import|CURRENT_STATIC#bottom') . '"><strong>IMPORT</strong></a>') . '</td>
 				<td>'.$this->fw('&nbsp;').'</td>
 			</tr>';
 
@@ -3384,9 +3384,9 @@
 
 			$out.='<tr>
 				<td nowrap="nowrap">'.$this->fw($fShortName.' ('.t3lib_div::formatSize(filesize($file)).')').'</td>
-				<td'.($action_type=='cmpFile|'.$file?' class="note"':'').'>'.$this->fw('<a href="'.htmlspecialchars($this->action.'&TYPO3_INSTALL[database_type]=cmpFile|'.rawurlencode($file).'#bottom').'"><strong>COMPARE</strong></a>').'</td>
-				<td nowrap="nowrap"'.($action_type=='import|'.$file?' class="note"':'').'>'.$this->fw('<a href="'.htmlspecialchars($this->action.'&TYPO3_INSTALL[database_type]=import|'.rawurlencode($file).'#bottom').'"><strong>IMPORT'.$spec1.$spec2.'</strong></a>').'</td>
-				<td nowrap="nowrap"'.($action_type=='view|'.$file?' class="note"':'').'>'.$this->fw('<a href="'.htmlspecialchars($this->action.'&TYPO3_INSTALL[database_type]=view|'.rawurlencode($file).'#bottom').'"><strong>VIEW'.$spec1.$spec2.'</strong></a>').'</td>
+				<td' . ($action_type == 'cmpFile|' . $file ? ' class="information"' : '') . '>' . $this->fw('<a href="' . htmlspecialchars($this->action . '&TYPO3_INSTALL[database_type]=cmpFile|' . rawurlencode($file) . '#bottom') . '"><strong>COMPARE</strong></a>') . '</td>
+				<td nowrap="nowrap"' . ($action_type == 'import|' . $file ? ' class="information"' : '') . '>' . $this->fw('<a href="' . htmlspecialchars($this->action . '&TYPO3_INSTALL[database_type]=import|' . rawurlencode($file) . '#bottom') . '"><strong>IMPORT' . $spec1 . $spec2 . '</strong></a>') . '</td>
+				<td nowrap="nowrap"' . ($action_type == 'view|' . $file ? ' class="information"' : '') . '>' . $this->fw('<a href="' . htmlspecialchars($this->action . '&TYPO3_INSTALL[database_type]=view|' . rawurlencode($file) . '#bottom') . '"><strong>VIEW' . $spec1 . $spec2 . '</strong></a>') . '</td>
 			</tr>';
 		}
 			// TCA
@@ -3392,19 +3392,19 @@
 			// TCA
 		$out.='<tr>
 			<td></td>
-			<td colspan="3"'.($action_type=="cmpTCA|"?' class="note"':'').'><strong>'.$this->fw('<a href="'.htmlspecialchars($this->action.'&TYPO3_INSTALL[database_type]=cmpTCA|#bottom').'">Compare with $TCA</a>').'</strong></td>
+			<td colspan="3"' . ($action_type == "cmpTCA|" ? ' class="information"' : '') . '><strong>' . $this->fw('<a href="' . htmlspecialchars($this->action . '&TYPO3_INSTALL[database_type]=cmpTCA|#bottom') . '">Compare with $TCA</a>') . '</strong></td>
 		</tr>';
 		$out.='<tr>
 			<td></td>
-			<td colspan="3"'.($action_type=="adminUser|"?' class="note"':'').'><strong>'.$this->fw('<a href="'.htmlspecialchars($this->action.'&TYPO3_INSTALL[database_type]=adminUser|#bottom').'">Create "admin" user</a>').'</strong></td>
+			<td colspan="3"' . ($action_type == "adminUser|" ? ' class="information"' : '') . '><strong>' . $this->fw('<a href="' . htmlspecialchars($this->action . '&TYPO3_INSTALL[database_type]=adminUser|#bottom') . '">Create "admin" user</a>') . '</strong></td>
 		</tr>';
 		$out.='<tr>
 			<td></td>
-			<td colspan="3"'.($action_type=="UC|"?' class="note"':'').'><strong>'.$this->fw('<a href="'.htmlspecialchars($this->action.'&TYPO3_INSTALL[database_type]=UC|#bottom').'">Reset user preferences</a>').'</strong></td>
+			<td colspan="3"' . ($action_type == "UC|" ? ' class="information"' : '') . '><strong>' . $this->fw('<a href="' . htmlspecialchars($this->action . '&TYPO3_INSTALL[database_type]=UC|#bottom') . '">Reset user preferences</a>') . '</strong></td>
 		</tr>';
 		$out.='<tr>
 			<td></td>
-			<td colspan="3"'.($action_type=="cache|"?' class="note"':'').'><strong>'.$this->fw('<a href="'.htmlspecialchars($this->action.'&TYPO3_INSTALL[database_type]=cache|#bottom').'">Clear tables</a>').'</strong></td>
+			<td colspan="3"' . ($action_type == "cache|" ? ' class="information"' : '') . '><strong>' . $this->fw('<a href="' . htmlspecialchars($this->action . '&TYPO3_INSTALL[database_type]=cache|#bottom') . '">Clear tables</a>') . '</strong></td>
 		</tr>';
 
 		$theForm='<table border="0" cellpadding="2" cellspacing="2">'.$out.'</table>';
@@ -4711,24 +4711,20 @@
 	 * @param	integer		-1=OK sign, 0=message, 1=notification, 2=warning , 3=error
 	 * @return	void
 	 */
-	function printSection($head, $short_string, $long_string, $type)	{
-		$icon='';
-		$cssClass =' class="note"';
+	private function printSection($head, $short_string, $long_string, $type)	{
+		$cssClass = ' class="information"';
 		switch($type)	{
 			case '3':
 				$cssClass =' class="error"';
-				$icon = 'gfx/icon_fatalerror.gif';
 			break;
 			case '2':
 				$cssClass =' class="warning"';
-				$icon = 'gfx/icon_warning.gif';
 			break;
 			case '1':
-				$icon = 'gfx/icon_note.gif';
+				$cssClass = ' class="note"';
 			break;
 			case '-1':
 				$cssClass =' class="success"';
-				$icon = 'gfx/icon_ok.gif';
 			break;
 		}
 		if (!trim($short_string))	{
@@ -4735,8 +4731,8 @@
 			$this->sections[$head][]='';
 		} else {
 			$this->sections[$head][]='
-			<tr><td' . $cssClass . ' nowrap="nowrap">' . ($icon ? '<img src="' . $this->backPath . $icon . '" width="18" height="16" align="top" alt="">' : '') . '<strong>' . $this->fw($short_string) . '</strong></td></tr>' . (trim($long_string) ? '
-			<tr><td>' . $this->fw($long_string) . '<br /><br /></td></tr>' : '');
+			<tr><td' . $cssClass . ' nowrap="nowrap"><strong>' . $this->fw($short_string) . '</strong></td></tr>' .
+			(trim($long_string) ? ' <tr><td>' . $this->fw($long_string) . '<br /><br /></td></tr>' : '');
 		}
 	}
 
@@ -4939,7 +4935,7 @@
 	function note123()	{
 		if ($this->mode=='123')	{
 			$c='<table border="0" cellpadding="0" cellspacing="0" width="100%">
-				<tr><td class="note" nowrap="nowrap"><img src="'.$this->backPath.'gfx/icon_note.gif" width="18" height="16" align="top" alt=""><strong>'.$this->fontTag1.'NOTICE: Install Tool is running in \'123\' mode. <a href="'.$this->scriptSelf.'">Click here to disable.</a></span></strong></td></tr>
+				<tr><td class="note" nowrap="nowrap"><strong>' . $this->fontTag1 . 'NOTICE: Install Tool is running in \'123\' mode. <a href="' . $this->scriptSelf . '">Click here to disable.</a></span></strong></td></tr>
 			</table>';
 			return $c;
 		}
Index: typo3/sysext/install/mod/install.css
===================================================================
--- typo3/sysext/install/mod/install.css	(revision 5575)
+++ typo3/sysext/install/mod/install.css	(working copy)
@@ -94,10 +94,12 @@
 }
 
 .warning {
-	background-color: #ffc67f;
+	background: #ffc67f url(../../../gfx/icon_warning.gif) no-repeat;
+	padding-left: 18px;
 }
 .success {
-	background-color: #af5;
+	background: #af5 url(../../../gfx/icon_ok.gif) no-repeat;
+	padding-left: 18px;
 }
 
 .editFile {
@@ -112,7 +114,8 @@
 }
 
 .error {
-	background-color: #f66;
+	background: #f66 url(../../../gfx/icon_fatalerror.gif) no-repeat;
+	padding-left: 18px;
 }
 
 .siteInfo {
@@ -120,6 +123,11 @@
 }
 
 .note {
+	background: #d7dbe2 url(../../../gfx/icon_note.gif) no-repeat;
+	padding-left: 18px;
+}
+
+.information {
 	background-color: #d7dbe2;
 }
 