Index: typo3/mod/tools/em/class.em_index.php
===================================================================
--- typo3/mod/tools/em/class.em_index.php	(Revision 6130)
+++ typo3/mod/tools/em/class.em_index.php	(Arbeitskopie)
@@ -919,15 +919,15 @@
 										if ($inst_list[$extKey]['EM_CONF']['state'] != 'excludeFromUpdates') {
 											$loc= ($inst_list[$extKey]['type']=='G'?'G':'L');
 											$aUrl = 'index.php?CMD[importExt]='.$extKey.'&CMD[extVersion]='.$version.'&CMD[loc]='.$loc;
-											$loadUnloadLink .= '<a href="' . htmlspecialchars($aUrl) . '"><img src="' . $GLOBALS['BACK_PATH'] . 'gfx/import_update.gif" width="12" height="12" title="' . sprintf($GLOBALS['LANG']->getLL('do_update'), ($loc == 'G' ? $GLOBALS['LANG']->getLL('global') : $GLOBALS['LANG']->getLL('local'))) . '" alt="" /></a>';
+											$loadUnloadLink .= '<a href="' . htmlspecialchars($aUrl) . '"><img'.t3lib_iconWorks::skinImg($GLOBALS['BACK_PATH'], 'gfx/import_update.gif', 'width="12" height="12"').' title="' . sprintf($GLOBALS['LANG']->getLL('do_update'), ($loc == 'G' ? $GLOBALS['LANG']->getLL('global') : $GLOBALS['LANG']->getLL('local'))) . '" alt="" /></a>';
 										} else {
 												// extension is marked as "excludeFromUpdates"
-											$loadUnloadLink .= '<img src="' . $GLOBALS['BACK_PATH'] . 'gfx/icon_warning.gif" width="18" height="16" title="' . $GLOBALS['LANG']->getLL('excluded_from_updates') . '" alt="" />';
+											$loadUnloadLink .= '<img'.t3lib_iconWorks::skinImg($GLOBALS['BACK_PATH'], 'gfx/icon_warning.gif', 'width="18" height="16"').' title="' . $GLOBALS['LANG']->getLL('excluded_from_updates') . '" alt="" />';
 										}
 									} else {
 											// import
 										$aUrl = 'index.php?CMD[importExt]='.$extKey.'&CMD[extVersion]='.$version.'&CMD[loc]=L';
-										$loadUnloadLink .= '<a href="' . htmlspecialchars($aUrl) . '"><img src="' . $GLOBALS['BACK_PATH'] . 'gfx/import.gif" width="12" height="12" title="' . $GLOBALS['LANG']->getLL('import_to_local_dir') . '" alt="" /></a>';
+										$loadUnloadLink .= '<a href="' . htmlspecialchars($aUrl) . '"><img '.t3lib_iconWorks::skinImg($GLOBALS['BACK_PATH'], 'gfx/import.gif', 'width="12" height="12"').' title="' . $GLOBALS['LANG']->getLL('import_to_local_dir') . '" alt="" /></a>';
 									}
 								} else {
 									$loadUnloadLink = '&nbsp;';
@@ -2096,7 +2096,7 @@
 												list($new_list)=$this->getInstalledExtensions();
 												$content.=$this->updatesForm($extKey,$new_list[$extKey],1,'index.php?CMD[showExt]='.$extKey.'&SET[singleDetails]=info');
 											}
-											
+
 											$flashMessage = t3lib_div::makeInstance(
 												't3lib_FlashMessage',
 												$content,
@@ -2494,8 +2494,7 @@
 								$eC=2;
 							}
 							if (!$this->fe_user['username'])	{
-								$content .= '<br /><br /><img src="' . $GLOBALS['BACK_PATH'] .
-									'gfx/icon_note.gif" width="18" height="16" align="top" alt="" />' .
+								$content .= '<br /><br /><img '.t3lib_iconWorks::skinImg($GLOBALS['BACK_PATH'], 'gfx/icon_note.gif', ' width="18" height="16"').' align="top" alt="" />' .
 									sprintf($GLOBALS['LANG']->getLL('ext_details_no_username'),
 										'<a href="index.php?SET[function]=3">', '</a>'
 									) .
@@ -3470,14 +3469,14 @@
 			if (!$import) {		// Listing extension on LOCAL server:
 					// Extension Download:
 				$cells[] = '<td nowrap="nowrap"><a href="' . htmlspecialchars('index.php?CMD[doBackup]=1&SET[singleDetails]=backup&CMD[showExt]=' . $extKey) . '">
-					<img src="download.png" width="13" height="12" title="' . $GLOBALS['LANG']->sL('LLL:EXT:lang/locallang_common.xml:download') . '" alt="" /></a></td>';
+					<img'.t3lib_iconWorks::skinImg($GLOBALS['BACK_PATH'], 'mod/tools/em/download.png', 'width="13" height="12"').' title="' . $GLOBALS['LANG']->sL('LLL:EXT:lang/locallang_common.xml:download') . '" alt="" /></a></td>';
 
 					// Manual download
 				$fileP = PATH_site.$this->typePaths[$extInfo['type']].$extKey.'/doc/manual.sxw';
 				$cells[] = '<td nowrap="nowrap">'.
 				($this->typePaths[$extInfo['type']] && @is_file($fileP) ?
 					'<a href="' . htmlspecialchars(t3lib_div::resolveBackPath($this->doc->backPath . '../' . $this->typePaths[$extInfo['type']] . $extKey . '/doc/manual.sxw')).'" target="_blank">
-					<img src="oodoc.gif" width="13" height="16" title="' . $GLOBALS['LANG']->getLL('listRow_local_manual') . '" alt="" /></a>' : '').
+					<img'.t3lib_iconWorks::skinImg($GLOBALS['BACK_PATH'], 'mod/tools/em/oodoc.gif', 'width="13" height="16"').' title="' . $GLOBALS['LANG']->getLL('listRow_local_manual') . '" alt="" /></a>' : '').
 				'</td>';
 
 					// Double installation (inclusion of an extension in more than one of system, global or local scopes)
@@ -3617,7 +3616,7 @@
 	 * @return	string		<img> tag
 	 */
 	function removeButton()	{
-		return '<img src="uninstall.gif" width="16" height="16" title="' .
+		return '<img'.t3lib_iconWorks::skinImg($GLOBALS['BACK_PATH'], 'mod/tools/em/uninstall.gif', 'width="16" height="16"').' title="' .
 			$GLOBALS['LANG']->getLL('ext_details_remove_ext') . '" align="top" alt="" />';
 	}
 
@@ -3627,7 +3626,7 @@
 	 * @return	string		<img> tag
 	 */
 	function installButton()	{
-		return '<img src="install.gif" width="16" height="16" title="' .
+		return '<img'.t3lib_iconWorks::skinImg($GLOBALS['BACK_PATH'], 'mod/tools/em/install.gif', 'width="16" height="16"').' title="' .
 			$GLOBALS['LANG']->getLL('helperFunction_install_extension') . '" align="top" alt="" />';
 	}
 
@@ -3637,7 +3636,7 @@
 	 * @return	string		<img> + text string.
 	 */
 	function noImportMsg()	{
-		return '<img src="' . $this->doc->backPath . 'gfx/icon_warning2.gif" width="18" height="16" align="top" alt="" />
+		return '<img'.t3lib_iconWorks::skinImg($GLOBALS['BACK_PATH'], 'gfx/icon_warning2.gif', 'width="18" height="16"').' align="top" alt="" />
 			<strong>' . $GLOBALS['LANG']->getLL('helperFunction_import_not_possible') . '</strong>';
 	}
 
@@ -4943,8 +4942,7 @@
 					if(!isset($instExtInfo[$depK]))	{
 						$msg[] = '<br />' . sprintf($GLOBALS['LANG']->getLL('checkDependencies_ext_not_available'),
 							$depK);
-						$msg[] = '&nbsp;&nbsp;&nbsp;&nbsp;<img src="' . $GLOBALS['BACK_PATH'] .
-							'gfx/import.gif" width="12" height="12" title="' . $GLOBALS['LANG']->getLL('checkDependencies_import_ext') . '" alt="" />&nbsp;
+						$msg[] = '&nbsp;&nbsp;&nbsp;&nbsp;<img'.t3lib_iconWorks::skinImg($GLOBALS['BACK_PATH'], 'gfx/import.gif', 'width="12" height="12"').' title="' . $GLOBALS['LANG']->getLL('checkDependencies_import_ext') . '" alt="" />&nbsp;
 							<a href="index.php?CMD[importExt]=' . $depK . '&CMD[loc]=L&CMD[standAlone]=1" target="_blank">' . $GLOBALS['LANG']->getLL('checkDependencies_import_now') . '</a>';
 						$msg[] = '&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" value="1" name="depsolver[ignore][' . $depK . ']" id="checkIgnore_' . $depK . '" />
 							<label for="checkIgnore_' . $depK . '">' . $GLOBALS['LANG']->getLL('checkDependencies_ignore_ext_requirement') . '</label>';
@@ -5041,8 +5039,7 @@
 					if (!isset($instExtInfo[$suggestK]))	{
 						$msg[] = sprintf($GLOBALS['LANG']->getLL('checkDependencies_suggest_import'),
 							$suggestK);
-						$msg[] = '&nbsp;&nbsp;&nbsp;&nbsp;<img src="' . $GLOBALS['BACK_PATH'] .
-							'gfx/import.gif" width="12" height="12" title="' . $GLOBALS['LANG']->getLL('checkDependencies_import_ext') . '" alt="" />&nbsp;
+						$msg[] = '&nbsp;&nbsp;&nbsp;&nbsp;<img'.t3lib_iconWorks::skinImg($GLOBALS['BACK_PATH'], 'gfx/import.gif', 'width="12" height="12"').' title="' . $GLOBALS['LANG']->getLL('checkDependencies_import_ext') . '" alt="" />&nbsp;
 							<a href="index.php?CMD[importExt]=' . $suggestK . '&CMD[loc]=L&CMD[standAlone]=1" target="_blank">' . $GLOBALS['LANG']->getLL('checkDependencies_import_now') . '</a>';
 						$msg[] = '&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" value="1" name="depsolver[ignore][' . $suggestK . ']" id="checkIgnore_' . $suggestK . '" />
 							<label for="checkIgnore_' . $suggestK . '">' . $GLOBALS['LANG']->getLL('checkDependencies_ignore_suggestion') . '</label>';
@@ -5403,8 +5400,7 @@
 							<td><img src="clear.gif" width="10" height="1" alt="" /></td>
 							<td nowrap="nowrap">' .
 								($exist ?
-									'<img src="' . $GLOBALS['BACK_PATH'] .
-									'gfx/icon_warning.gif" width="18" height="16" align="top" alt="" />' .
+									'<img'.t3lib_iconWorks::skinImg($GLOBALS['BACK_PATH'], 'gfx/icon_warning.gif', 'width="18" height="16"').' align="top" alt="" />' .
 									$GLOBALS['LANG']->getLL('checkDBupdates_table_exists')
 									: '') .
 							'</td>